#!/bin/env python
# vim:fileencoding=utf-8:ft=python
#
# A clock
# Image borrowed from gdeskle
# 
import gtk, cairo, os, time, math, gobject

def _drawClock(widget, event):
	global clock

	# Create cairo context
	context = widget.window.cairo_create()
	context.set_source_rgba(0.0, 0.0, 0.0, 0.0)
	context.set_operator(cairo.OPERATOR_SOURCE)

	# Calculate angles
	secs = (2 * math.pi / 60) * time.localtime().tm_sec - math.pi / 2
	minutes = (2 * math.pi / 60) * time.localtime().tm_min - math.pi / 2
	hours = (2 * math.pi / 12) * (time.localtime().tm_hour % 12) + minutes / 12 - math.pi / 2

	# Draw
	context.paint()
	widget.window.draw_pixbuf(None, clock, 0, 0, 0, 0, 136, 137, gtk.gdk.RGB_DITHER_NONE, 0, 0)
	context.set_source_rgba(0.0, 0.0, 0.0, 0.8)
	context.set_line_width(2)
	center = (67, 70)
	context.move_to(center[0], center[1])
	context.line_to(center[0] + 40 * math.cos(hours), center[0] + 40 * math.sin(hours))
	context.stroke()
	context.move_to(center[0], center[1])
	context.set_line_width(1)
	context.line_to(center[0] + 50 * math.cos(minutes), center[1] + 50 * math.sin(minutes))
	context.stroke()
	context.move_to(center[0], center[1])
	context.set_source_rgba(0.0, 0.0, 1.0, 0.8)
	context.line_to(center[0] + 50 * math.cos(secs), center[1] + 50 * math.sin(secs))
	context.stroke()

	return False

def initialize():
	# Load image
	global clock
	clock = gtk.gdk.pixbuf_new_from_file(os.path.join(pluginDirectory, "clock.png"))
	# Connect event for drawing
	widget.connect("expose-event", _drawClock)
	def redraw():
		widget.queue_draw()
		return True
	gobject.timeout_add(1000, redraw)
	widget.set_size_request(137, 137)
	window.show_all()
