#!/bin/env python
# vim:fileencoding=utf-8:ft=python
#
# POP3 Email check
# SSL Erweiterung von Sir Diego (tim, http://www.sirdiego.de/#)
#

import gtk
import gobject
import shelve
import base64
import sys
import poplib

# Base64 encoded icon
mailIcon = """
R0lGODlhMAAwAPf4AO/o7e7h5e/c3u/Y2e7NzPTduue4tOS+u+XFw9zc9r6+ 5qam4pWV16am2MTE3+Tk6uWuqe3cpdaUi9qZjtmgltqqnd61sOfZ3NbW8K2t
5ZGR37Oz5cPD8by88r6+2O3HxOi0rd6Qheq9hd+Xa99sUtZ6ad6OgtelocGk u52MzsXF97i475mZzM7O1Ofn7uB/a+ViSe2LUvXUgOJTLuhZL99bQNBsbdW4
ncSVpM6kvsW12czM/4SExbKy0N7e5eF5Y+lbOut5QP7+j+ZrI+V0MPCfV+mn fdiDic+ZrI6Ox56exdbW3P/vZfCsVfnNcfGmS//sf/rMfO1MOt50b9aOnImJ
u8XFz+JgJv/2k//kWv3oa/7jVf/gYf/zcvNkJfFZL7y8we3Nu//lSf/XIf/S E/eKMNOToaur3ISErq6ux+GOZP/3Xf/MAPvggvR9O7Cwttvb4vq9XP/jPf/M
ZvJ0GPBWHsZ7dLyLj7Kcq7e32KSktPluJ+ZrSuOYhtK8tszMzMfHxbu7uLW1 s62uq6amo6OjoJmZmf//mf+Pa/+1p//Uyv/w6P/////bLf+ILv93Nv+PVP/M
mf/asv/Wv///9nt7pMJxhtxSRu1MKfamWP9lKf9xT/+vj//DqP/36f/58JWU jLeMuLh2mcxmZutzSfSWTP+EO/9mM/9pP/+3nv/Ps//ly3p6nq2NyvLwnf+0
X//u3P/34JaOe5SUvbW1upyc1ujBz/LZs/9cOP9zSoSEvIWFiJqa7f/g2cSF qdZwT/+AV/+mgv+9l//ovf/v1nJydd7e///w7dypubV5pv+zhv/vy8y/wXt8
vNbW55ub5rqRvfe9nf/epf/wxOjYxNfG39O5vf/mrv/mtvf3///stdPEu3Jy k7+yv4ODzqSbv9nHtZeXv+/v/6Skx9DQ6M/P9ubm/4uL0nNzjXd3q4uLsHFx
hNbW/4GBoXJyfGxsfG1tgWtrcsXF/3t7k3h4h2ZmZoyMkHl5ff///wAAAAAA AAAAAAAAAAAAAAAAAAAAACH5BAHoA/gALAAAAAAwADAAAAj/APEJHIgPQAAB
AgYMCACAoMOHECNGBDCAQAEDGA0cQDCgocAEChYwYNDAwQOJKB0GIHAAQgQJ EiZMoFDBAoILGDJoWLCBQ4cMIz2cTClRwAcQFEKIGEGiaQkTEk6gSJGBg1Wr
KlSsYMCihQuiDwN8gDDhBYwYMmbQWFvDxg0cOXR0uJp1h90FPHr4ADsQAAEQ E34AoRFEyBAiRWbMkGHkCJIcCrDWtbuDQxIlS76CHXCAwgsgQYgMYdLEyZMh
UKJImUIlrmTKsFlUsaIZpV8IJmDQuILlSRYtW5xw6eLlCwzHOV7DptygCpih EgOEiSAiRpAhT8RkGUNmi5gyXopP/zEDmcPk5XbPoEmzt6gBCWpkCFmTJQub
+2y0cGnj5guJ1jqch55dG6DxBhwSDQCCBDDMQEQcW5CBHxtyzEGHF3XUYMcd eKThYQ95hJiHAiSWWKAeCEKk4AQk7PbEFhOyMUYWcezxBR99VODHH4D0CEYg
ggQ5yCCEEFLIkYbosYSKBrA4QxFOzMHEhFBkwcQhUSCSiCKLMOLll2CGyYgh aKAYVmclKFbHHGMw0QgZXTDhyB6PQBKJJJMsQsmefPbpJyWGbFCJmQQBgMAJ
llyCSSZrxMEFFBXOMYcmmmzCSSeKePLJppx26ikloChwxqApDjRAKKKMQsoh pdSBhSNccP+hiSmnoIJIKqqs4smuvPbq666hKtAAK4QKFEArqLpCCiZ1vKLJ
K1BQauulk8ASy7XYZqvttbKUOAsatECHTy223CKKDTVgcsq6h+CSCyKX5grL vPTWa++8sXTbgC5JVLLLkgPx4kMvH/hiyS+IAAMMFogEw4kwqgxDzMQUV2xx
xbIkkcQDD1RSTAsE8WLMMb0ogkwyEyijTCSRCNNJxMvELPPMNM/MTDMeeOkM Kx8T9IwxXi7SCwHQQBNNJNJII8kw0zTt9NNQO01NFSzg8+XOPQ/0TAJgfnJM
NSlYcw02w5Rt9tlon50GD86EiTXIWnMtZjYZNFCANtjkrffefGP/s40ueYjJ iDPcZC3Q1oJ7iQEDzFzjuOPdJOGNN9+A8/gt4SRhteCEG44P4nNnk404Z4xz
yzXdeLOB1dmQIxs43fBATuI6Fw63QAzIDabo4vQuTjkssNBANmImUEUzxNPO yBK2E5T77ryLY870CZzDgfI9oOECI6J33/3y6Hhei+7c+z69OeV4g4HyOqfj
wOi++55NC+Hfjs/zXvJ+vjkqeLM9+17CBxp6IL39mUMcDqif8+QWvekZI32b A+CX1KEEcxjjgsaYngfW4TkGrK+BFkwf+SToJXWEwxjsSGEGN9jBD/bOgexQ
HwC9R0N1zCKFKswDB+3nwfJJ74LnmF2Y/2hIw/j5rh3hoAw78uAOd9iPBRiA nwMZsAHuETF6RnyhAduhBLuwowdNfGIUC2iODNTCe1k0nwHXaEF0jMMuPXiH
56AoRQ6cI41sPB8G97jHcsDjDDuI4xzJMTpzxDABZFwjHzGIw0Y2UgHv6EAD 4jHIQp5DAftb5AUdyUl2DOgM6xgHJe0XDkKKowENsOAeO+nIAblyFvEYJUFK
mQ0OeAOFrEyhK9EjjxWcQQmzaMc83kHMMM6SHOLggQpauUvKyOMnDQiHOtqB DnjAgx7YbGIs6xEPQwBMIOFwBgsy4MldPnMDDWDBt1jBDW7MYx7Z3GY9irEL
exiCEG8AgxUyM4lLFjBgOR3YwBlqIRs0VOKg76SHO+JRD27eo573pIU+W9CC JcDBBw+oDUFmwYMFLIAFSdCFSNEgTIUydJ4PNYQhBiHRP1TUoj5wgUZTooQq
lHShDS1GSgvBUkC4dAlL8EFMZ8oXgsDBELvYhSEKkU8rUBSoGJVpUafqAjgA 9aIZJepUt8rVrkokIAA7 ====
"""
settings = infoLabel = infoImage = 1

def config(param):
	"""
		Show configuration dialog
	"""
	global settings
	# Create dialog
	configWindow = gtk.Dialog()
	configWindow.set_modal(True)
	# Add table with entries
	table = gtk.Table(2, 4, False)
	table.show()
	configWindow.vbox.add(table)
	server = gtk.Entry()
	if "server" in settings:
		server.set_text(settings["server"])
	table.attach(gtk.Label("Server: "), 0, 1, 0, 1, 0, 0, 0, 0)
	table.attach(server, 1, 2, 0, 1, 0, 0, 0, 0)
	user = gtk.Entry()
	if "user" in settings:
		user.set_text(settings["user"])
	table.attach(gtk.Label("User: "), 0, 1, 1, 2, 0, 0, 0, 0)
	table.attach(user, 1, 2, 1, 2, 0, 0, 0, 0)
	password = gtk.Entry()
	password.set_visibility(False)
	if "pass" in settings:
		password.set_text(settings["pass"])
	table.attach(gtk.Label("Password: "), 0, 1, 2, 3, 0, 0, 0, 0)
	table.attach(password, 1, 2, 2, 3, 0, 0, 0, 0)
	ssl = gtk.CheckButton(label="SSL")
	if "ssl" in settings and settings["ssl"] == 1:
		ssl.set_active(1)
	table.attach(ssl, 0, 1, 3, 4, 0, 0, 0, 0)

	# Add an "ok" button
	okButton = gtk.Button("Save")
	def saveChanges(param):
		# Action handler, save settings
		settings["server"] = server.get_text()
		settings["user"] = user.get_text()
		settings["pass"] = password.get_text()
		settings["ssl"] = 0
		if ssl.get_active():
			settings["ssl"] = 1
		settings.sync()
		configWindow.destroy()
	okButton.connect("clicked", saveChanges)
	configWindow.action_area.add(okButton)
	# Show dialog
	configWindow.show_all()
	configWindow.show()

def popCheck(*param):
	"""
		Check the predefined POP3 account
	"""
	global infoLabel, settings
	if "server" in settings:
		try:
			# Connect, USER, PASS, LIST
			if settings["ssl"] == 1:
				connection = poplib.POP3_SSL(settings["server"])
			else:
				connection = poplib.POP3(settings["server"])
			connection.user(settings["user"])
			connection.pass_(settings["pass"])
			list = connection.list()[1]
			# Format message
			if len(list) == 0:
				text = "You don't have any new messages"
			elif len(list) == 1:
				text = "You have one unread message"
			else:
				text = "You have %d unread messages" % len(list)
			# Set message in info label
			infoLabel.set_text(text)
		except:
			infoLabel.set_text("Failed to check emails")
	gobject.timeout_add(1800000, popCheck)
	return False

def initialize():
	global settings, infoLabel
	# Load settings
	settings = shelve.open("%s/settings" % settingsDirectory)

	# Initialize GUI
	infoLabel = gtk.Label("No pop3 settings")
	infoImage = gtk.Image()
	loader = gtk.gdk.PixbufLoader()
	loader.write(base64.b64decode(mailIcon))
	infoImage.set_from_pixbuf(loader.get_pixbuf())
	loader.close()

	hbox = gtk.HBox()
	hbox.add(infoImage)
	hbox.add(infoLabel)
	widget.add(hbox)
	window.show_all()
	
	# Initialize menu
	configMenu = gtk.MenuItem("Configure")
	configMenu.connect("activate", config)
	configMenu.show()
	menu.add(configMenu)

	updateMenu = gtk.MenuItem("Update now")
	updateMenu.connect("activate", popCheck)
	updateMenu.show()
	menu.add(updateMenu)

	# Do an asynchronous POP3 check
	gobject.timeout_add(10, popCheck)
